package graphs;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map.Entry;

public class Graph {
	
	Hashtable<Integer, Vertex> vertices = new Hashtable<Integer, Vertex>(); 
	ArrayList<Edge> edges = new ArrayList<Edge>();
	
	/* add an egde to the graph */
	public Edge addEdge(int startV, int endV) throws Exception {
		// check if the edge already exist
		for (Edge e : edges) 
			if (e.SV.id == startV && e.EV.id == endV)
				throw new Exception("The edge (" + startV + "," + endV + ") already exists!");

		// get the starting and ending vertex of the edge if they exist
		Vertex SV = vertices.get(startV);
		Vertex EV = vertices.get(endV);
		
		// create vertices if they do not exist
		if (SV == null) {
			SV = new Vertex(startV);
			vertices.put(startV, SV);
		}
		if (EV == null) {
			EV = new Vertex(endV);
			vertices.put(endV, EV);
		}
	
		// create the edge
		Edge e = new Edge(SV, EV);
		edges.add(e);
		return e;
	}
	
	/* topological sort */
	public void TS(List<Vertex> ts_v, List<Edge> ts_e) {
		// implement me!
	}
	
	public static void main(String[] args) throws Exception {
		Graph g = new Graph();
		g.addEdge(1, 2); g.addEdge(1, 5); g.addEdge(1, 3); 
		g.addEdge(2, 4); g.addEdge(2, 5); g.addEdge(5, 7); 
		g.addEdge(5, 9); g.addEdge(5, 6); g.addEdge(3, 5); 
		g.addEdge(3, 6); g.addEdge(4, 7); g.addEdge(7, 9);
		g.addEdge(6, 8); g.addEdge(8, 7); g.addEdge(8, 9);
		
		ArrayList<Vertex> ts_v = new ArrayList<Vertex>();
		ArrayList<Edge> ts_e = new ArrayList<Edge>();
		
		g.TS(ts_v, ts_e);
		
		for (Vertex v : ts_v)
			System.out.println(v);
		
		for (Edge e : ts_e)
			System.out.println(e);
	}
}
